--[[ Harvest Lua initialization file.

     This file is called before any mods are loaded.

     Please do not modify.
     
     If you want changes in this file you should
     suggest them in the Oxeye forums,
     http://www.oxeyegames.com/forum/
]]

print = harvest.print
dofile = harvest.dofile

ALIEN_DEFAULT = 1
ALIEN_SHIELDER = 2
ALIEN_TINY = 3
ALIEN_SUMMONER = 4
ALIEN_LOOKER = 5
ALIEN_MINER = 6
ALIEN_STEALER = 7
ALIEN_MAGNETO = 8
ALIEN_MEGA = 9

-- Load table serialization script by chillcode
dofile("table.save-0.94.lua")

-- HOOK CLASS
-- Thanks to Robert Moschos

hook = {}
hook.Hooks = {}

function hook.getTable()
	return hook.Hooks
end

function hook.add(Name, Function)
	hook.Hooks[Name] = hook.Hooks[Name] or {}
			
	local NumHooks = #hook.Hooks[Name]
	hook.Hooks[Name][NumHooks + 1] = Function
end

function hook.call(Name, arg1, arg2, arg3, arg4)
	local HookTable = hook.Hooks[Name]

	if (HookTable) then
		for k, v in pairs(HookTable) do
			if not (v) then
				print("Hook '"..Name.."' tried to call a nil function!")
				hook.Hooks[Name][k] = nil
			else
				v(arg1, arg2, arg3, arg4)
			end
		end
		return 0
	else
		return 1
	end
end
